"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
function getHighlightAPI() {
  if (globalThis.highlight === void 0) {
    throw new Error(
      "Your web app must be running in the Highlight app to use this module. Please see https://docs.highlight.ing for more details."
    );
  }
  return globalThis.highlight;
}
function awaitNextTextPrediction(id) {
  const api2 = getHighlightAPI();
  return new Promise((resolve) => {
    const createListener = () => {
      api2.once("onTextPredictionUpdate", (message) => {
        if (message.id !== id) {
          createListener();
          return;
        }
        resolve(message.text);
      });
    };
    createListener();
  });
}
var api = {
  user: {
    getFacts: () => getHighlightAPI().user.getFacts(),
    getAudio: (longAudio) => getHighlightAPI().user.getAudio(longAudio),
    setAsrRealtime: (isActive) => getHighlightAPI().user.setAsrRealtime(isActive),
    getMicActivity: (lastNumMs) => getHighlightAPI().user.getMicActivity(lastNumMs),
    getScreenshot: () => getHighlightAPI().user.getScreenshot(),
    getEmail: () => getHighlightAPI().user.getEmail()
  },
  auth: {
    signIn: () => getHighlightAPI().auth.signIn()
  },
  inference: {
    getTextPrediction: async function* (messages) {
      const api2 = getHighlightAPI();
      const id = await api2.internal.getTextPrediction(messages);
      let done = false;
      const onTextPredictionDoneListener = (message) => {
        if (message.id !== id) {
          return;
        }
        done = true;
      };
      api2.addEventListener(
        "onTextPredictionDone",
        onTextPredictionDoneListener
      );
      while (!done) {
        yield await awaitNextTextPrediction(id);
      }
      api2.removeEventListener(
        "onTextPredictionDone",
        onTextPredictionDoneListener
      );
    }
  },
  addEventListener: (event, listener) => {
    getHighlightAPI().addEventListener(event, listener);
  },
  removeEventListener: (event, listener) => {
    getHighlightAPI().removeEventListener(event, listener);
  },
  once: (event, listener) => {
    getHighlightAPI().once(event, listener);
  }
};
var src_default = api;
//# sourceMappingURL=index.cjs.map